MODULE Maus;

IMPORT B:=Spielbrett,G:=Grund,S:=Spez,Sch:=SchalterInit,
       X:=ColorPlane,Buttons,A:=Ausgaben,Rn;
 
VAR    Feld      : ARRAY 2,11 OF Buttons.MausfeldT;
       Schalter  : Sch.SchalterfeldT;
       
PROCEDURE FeldInit;
VAR     x,y,h,l,i : INTEGER;
BEGIN
  x:=10;y:=Sch.yStrich+Sch.abstStrich DIV 2;h:=Sch.abstStrich;l:=150;
  FOR i := 0 TO 10 DO 
    Feld[0,i].Init(x,y,l,h);
    y:=y+h;
  END;
  x:=3*x+2*l;y:=Sch.yStrich+Sch.abstStrich DIV 2;
  FOR i := 0 TO 10 DO 
    Feld[1,i].Init(x,y,l,h);
    y:=y+h;
  END;
END FeldInit;

PROCEDURE FeldGetroffen (VAR nr:INTEGER;VAR w:LONGINT;t:ARRAY OF CHAR);
VAR   ok  : BOOLEAN;
      i   : INTEGER;

   PROCEDURE Pot(i: INTEGER):LONGINT;     (* 10 hoch i errechnen *)
   VAR       p: LONGINT; n:INTEGER;
   BEGIN
     p:=1;
     FOR n:=1 TO i DO
       p:=10*p;
     END;
     RETURN p;
   END Pot;

BEGIN
  G.TextAusgeben(t);
  ok := FALSE;
  REPEAT
    i :=SHORT(ENTIER(Rn.ZufZahl()*11));
    nr:=SHORT(ENTIER(Rn.ZufZahl()*2));
    IF Feld[nr,i].Getroffen() THEN           (* Feldwerte 1 .. 100000 errechnen *) 
      IF ODD(i) THEN
        w := 5*Pot(i DIV 2);
      ELSE
        w := Pot(i DIV 2);  
      END;
      ok := TRUE;
      IF nr=1 THEN
        INC(nr);
      END;
    END;
  UNTIL ok;
  G.TextLoeschen;
END FeldGetroffen;

PROCEDURE SchalterGetroffen*(VAR s: BOOLEAN;modus: INTEGER);
VAR     ok,c1,c2 : BOOLEAN;
        zahl,Wert: LONGINT;
        d,i,nr   : INTEGER;  

BEGIN
  ok:=FALSE;
  REPEAT
    i:=SHORT(ENTIER(Rn.ZufZahl()*Sch.AnzSch));
    IF Schalter[i].Getroffen() THEN
      c1:=FALSE;c2:=FALSE;
      CASE i OF
        0 : c1 := TRUE;
            G.Eingeben (zahl,1);
            G.Numeration(0,zahl,modus);
      | 1 : c2 := TRUE;                
            G.Eingeben (zahl,2);
            G.Numeration(1,zahl,modus);
      | 2 : G.Elevieren1(2,modus);                        (* Hherlegen *)
      | 3 : FeldGetroffen (nr,Wert,"zum Hherlegen");          (* Hher *)
            IF Wert<100000 THEN
              G.Elevieren2(nr,Wert,modus);
            END;
      | 4 : IF B.Leer(0) & B.Leer(1) THEN                    (* Ausgeben *)
                 G.Ausgeben (G.ResultatErmitteln(2),1);
            ELSE
              IF (modus=4)&(G.ResultatErmitteln(0)<G.ResultatErmitteln(1)) THEN
                 G.Ausgeben (G.ResultatErmitteln(2),1);   (* Div mit Rest *)
                 G.Ausgeben (G.ResultatErmitteln(0),0);
              END;    
            END;    
      | 5 : IF modus=1 THEN
              IF ~B.Leer(0) THEN
                S.Addieren(modus); 
              END;
            END;  
      | 6 : IF modus=2 THEN                            (* M --> R *)
              FeldGetroffen (nr,Wert,"im linken Feld");
              S.Kopieren23  (Wert,modus); 
            END;  
      | 7 : IF modus=3 THEN
              S.Subtrahieren1(modus);
            END;  
      | 8 : IF modus=4 THEN                           (* Wegnehmen Division *)
              FeldGetroffen (nr,Wert,"zum Wegnehmen im linken Feld");
              d := G.Zeile  (Wert);
              d := (d-B.Maximum(1)) DIV 2;
              IF d>-1 THEN
                S.Wegnehmen(d,modus);
              END;
            END;
      | 9 : FeldGetroffen(nr,Wert,"zum Tieferlegen im linken Feld");    (* Tiefer *)
            IF Wert>1 THEN
               G.Resolvieren(0,Wert,modus);
            END;
      | 10: IF (modus=2) OR (modus=4) THEN
              IF B.Leer(0) THEN
                B.FeldLoeschen(1,modus)
              END;
            END;
      | 11: IF modus=3 THEN                           (* Wegnehmen Subtr *)
              FeldGetroffen(nr,Wert,"zum Wegnehmen im linken Feld");
              S.Subtrahieren2(Wert,modus);
            END;
      | 12: IF modus=3 THEN
              S.Verschieben13(modus);                 (* L-->R *)
            END;  
      | 13: s   := TRUE;
            ok  := TRUE;                                 
      | 14: s   := FALSE;
            ok  := TRUE;
      | 15: A.Schneller;
      | 16: A.Langsamer; 
      ELSE
        HALT(102);      
      END;
    END;
  UNTIL ok;
END SchalterGetroffen;

BEGIN
  FeldInit;
  Sch.Init(Schalter);
END Maus.
