MODULE Rn;
IMPORT W:= Windows, F:=Float;
TYPE   tText = ARRAY OF CHAR;
VAR    z     : LONGINT;
  
PROCEDURE NiceReal* (x: REAL; v,n: INTEGER; VAR t: tText);
VAR       h : ARRAY 30 OF CHAR;
BEGIN
  F.StrF (x,v,n,t);
END NiceReal;

PROCEDURE ZufZahl*() : REAL;
CONST a =      16807;
         m = 2147483647;
         q = m DIV a;
         r = m MOD a;
VAR   gamma : LONGINT; 
BEGIN
     gamma:= a * (z MOD q) - r * (z DIV q);
     IF gamma > 0 THEN 
       z:= gamma 
     ELSE 
       z:= gamma + m
     END;
     RETURN z * (1.0 / m);
END ZufZahl;


PROCEDURE InitSeed* ( seed : LONGINT );
BEGIN 
     z:= seed;
END InitSeed;


PROCEDURE Randomize*;
VAR z : LONGINT;
BEGIN
     z:= W.GetTickCount();
     IF z < 0 THEN z := -z END;
     InitSeed(z)
END Randomize;

BEGIN
  z:=314159; 
END Rn.
