MODULE Spielbrett;

IMPORT X:=ColorPlane,A:=Ausgaben,St:=Strings,F:=Float,
       Sch:=SchalterInit;

TYPE Spielbrett = ARRAY 3, 11 OF 
                                RECORD
                                    gesamt*, hohl*: INTEGER
                                END; 
                        
 (* 1. Index: 0 (linkes Feld), 1 (mittleres Feld), 2 (rechtes Feld),
    2. Index: Zeile 0 (1), 1 (5), 2 (10), 3 (50), 4 (100), 5 (500), 6 (1000), 
    7 (5000), 8 (10000), 9 (50000), 10 (100000) *)

VAR brett*    : Spielbrett;
    Schalter  : Sch.SchalterfeldT; 
    
PROCEDURE StricheZeichnen;
VAR x,y,i  : INTEGER;
    z      : LONGINT;            (* Thomas *)
    
   PROCEDURE Ausg (z : LONGINT);
   VAR  h   : ARRAY 9 OF CHAR;
   BEGIN
     St.Str(z,h);
     X.GotoXY (485,y);
     X.WriteStr (h);
     y := y + Sch.abstStrich;
   END Ausg;
 
BEGIN                               
    FOR i := 0 TO 5 DO
      FOR x := 10 TO 481 DO X.Dot(x,Sch.yStrich+2*Sch.abstStrich*i,1) END;
    END;
    FOR y := Sch.yStrich-Sch.abstStrich TO Sch.yStrich+11*Sch.abstStrich DO X.Dot(167, y, 1) END;
    FOR y := Sch.yStrich-Sch.abstStrich TO Sch.yStrich+11*Sch.abstStrich DO X.Dot(324, y, 1) END;

    y := Sch.yStrich+8;                              
    FOR x := 0 TO 5 DO
      z := ENTIER(F.Exp (10,x));
      Ausg(z);
      z := 5 * z;
      IF z < 100001 THEN
        Ausg(z);
      END;
    END; 
END StricheZeichnen;            (* Thomas *)

PROCEDURE SpielsteinZeichnen(feld, zeile, position, modus: INTEGER);
 (* 1. Parameter (feld):  0 (links), 1 (mitte), 2 (rechts),
    2. Parameter (zeile): 0 (1), 1 (5), 2 (10), 3 (50), 4 (100), 5 (500), 6 (1000), 
                                    7 (5000), 8 (10000), 9 (50000), 10 (100000),
    3. Parameter (position): 0, 1, 2,... in Feld und Zeile,
    4. Parameter (modus): 0 (gefllt), 1 (hohl) *) 
VAR x, y, i, k: INTEGER;
BEGIN
    CASE feld OF
        0: x := 10
        | 1: x := 167
        | 2: x := 324
    END;
    x := x + position * 13;  
    y := Sch.yStrich + zeile * Sch.abstStrich;
     
    CASE modus OF
        0: FOR i := x - 4 TO x + 4 DO
                FOR k := y - 4 TO y + 4 DO
                    X.Dot(i, k, 1)
                END
            END
      | 1: FOR i := x - 4 TO x + 4 DO
                X.Dot(i, y - 4, 1)
            END;
            FOR i := x - 4 TO x + 4 DO
                X.Dot(i, y, 0)
            END;
            FOR k := y - 4 TO y + 4 DO
                X.Dot(x - 4, k, 1);
                X.Dot(x + 4, k, 1)
            END;
            FOR i := x - 4 TO x + 4 DO
                X.Dot(i, y + 4, 1)
            END        
    END
END SpielsteinZeichnen;

PROCEDURE Leer*(feld: INTEGER): BOOLEAN;
VAR leer: BOOLEAN;
        zeile: INTEGER;
BEGIN
    leer := TRUE;
    FOR zeile := 0 TO 10 DO
        leer := leer & (brett[feld, zeile].gesamt = 0)
    END;
    RETURN leer
END Leer;

(* Thomas *)

PROCEDURE SchalterZeichnen(mo: INTEGER); 
VAR     i : INTEGER;
BEGIN
   FOR i := 0 TO 4 DO
     Schalter[i].Zeichnen;
   END;
   CASE mo OF
     1 : Schalter[5].Zeichnen;
   | 2 : Schalter[6].Zeichnen;
         Schalter[9].Zeichnen;  
         Schalter[10].Zeichnen;
   | 3 : Schalter[7].Zeichnen;   
         Schalter[9].Zeichnen;   
         Schalter[11].Zeichnen;
         Schalter[12].Zeichnen;
   | 4 : Schalter[8].Zeichnen;
         Schalter[9].Zeichnen;
         Schalter[10].Zeichnen;      
   END;
   FOR i := 13 TO 16 DO
     Schalter[i].Zeichnen;
   END;  
END SchalterZeichnen;

PROCEDURE Ueberschrift (mo: INTEGER);
VAR       h : ARRAY 15 OF CHAR;
BEGIN
  CASE mo OF
    1 :  h := "Addition";
  | 2 :  h := "Multiplikation";
  | 3 :  h := "Subtraktion";
  | 4 :  h := "Division"; 
  END;
  X.GotoXY (20,Sch.yText);
  X.WriteStr(h); 
END Ueberschrift;
    
(* Thomas *)    

PROCEDURE AllesZeichnen*(pause: BOOLEAN; mo: INTEGER);
VAR i, k, n, differenz: INTEGER;
  
BEGIN
    X.SetScreenUpdate(FALSE);
    A.HgrZeichnen;
    StricheZeichnen;
    FOR i := 0 TO 2 DO
        FOR k := 0 TO 10 DO
            differenz := brett[i, k].gesamt - brett[i, k].hohl;
            FOR n := 1 TO differenz  DO
                SpielsteinZeichnen(i, k, n, 0)
            END;
            FOR n := differenz + 1 TO brett[i, k].gesamt DO
                SpielsteinZeichnen(i, k, n, 1)  
            END
        END
    END;
    SchalterZeichnen(mo);
    Ueberschrift(mo);
    X.SetScreenUpdate(TRUE);
    IF pause THEN A.Delay END;       (* 700 ms Pause *)
END AllesZeichnen;

PROCEDURE FeldLoeschen*(feld, mo: INTEGER);
VAR zeile: INTEGER;
BEGIN
    FOR zeile := 0 TO 10 DO 
        brett[feld, zeile].gesamt := 0;
        brett[feld, zeile].hohl := 0
    END;
    AllesZeichnen(FALSE,mo)
END FeldLoeschen;

PROCEDURE AllesLoeschen*(mo: INTEGER);  
VAR f: INTEGER;
BEGIN
    FOR f := 0 TO 2 DO
        FeldLoeschen(f,mo)
    END;
    AllesZeichnen(FALSE,mo)
END AllesLoeschen;


PROCEDURE Maximum*(feld: INTEGER): INTEGER;
VAR maximum, zeile: INTEGER;
BEGIN
    maximum := -1;
    FOR zeile := 0 TO 10 DO
        IF brett[feld, zeile].gesamt # 0 THEN maximum := zeile END
    END;
    RETURN maximum
END Maximum;

BEGIN
  Sch.Init(Schalter);
END Spielbrett.
